// debugEA_v2.mq4
extern int iFastMA =  8;
extern int iSlowMA = 24;

bool bPlus, bPrev; // TRUE if fast MA above slow MA, otherwise FALSE
int i, iPreBars, iTicket;
int iTrade; // 0 == no trade open, 1 == long trade open, 2 == short trade open


int init()
{ i = 1; 
  iTrade = 0;
  iPreBars = Bars; 
  return(0);
}


int start()
{ double dbN, dbM;
  if(Bars != iPreBars) // if new candle,
  { dbN = iMA(NULL, 0, iFastMA, 0, MODE_SMA, PRICE_CLOSE,   i)  // current MA differential 
        - iMA(NULL, 0, iSlowMA, 0, MODE_SMA, PRICE_TYPICAL, i); 
  
    dbM = iMA(NULL, 0, iFastMA, 0, MODE_SMA, PRICE_CLOSE,   i+1)  // previous MA differential
        - iMA(NULL, 0, iSlowMA, 0, MODE_SMA, PRICE_TYPICAL, i+1); 
  
    if(dbN >= 0) bPlus = true;  // Current fast MA is above or equal to current slow MA.
    else         bPlus = false; // Current fast MA is below current slow MA.

    if(dbM >= 0) bPrev = true;  // Previous fast MA is above or equal to previous slow MA.
    else         bPrev = false; // Previous fast MA is below previous slow MA.

    if(bPlus != bPrev) // if MA crossover,
    { if(iTrade == 1)
      { OrderClose(iTicket, 1, Bid, 8, White); // close long trade
        iTrade = 0;
      }
      if(iTrade == 2)
      { OrderClose(iTicket, 1, Ask, 8, White); // close short trade
        iTrade = 0;
      }
      if(bPlus) // FastMA crossed above SlowMA. Go long.
      { iTicket = OrderSend(Symbol(), OP_BUY, 1, Ask, 8, 0, 0, NULL, 1, 0, Green); 
        iTrade = 1;
      }
      else      // FastMA crossed below SlowMA. Go short.   
      { iTicket = OrderSend(Symbol(), OP_SELL, 1, Bid, 8, 0, 0, NULL, 1, 0, Red);
        iTrade = 2;      
      }
    } // END if(bPlus != bPrev)
    iPreBars = Bars;
  } // END if(Bars != iPreBars)
  return(0);
} // END start()


int deinit()
{ return(0);
}